#include "chapter_2_tests.h"
#include "constexp.h"
#include "delegate_constructor.h"
#include "if_constexpr.h"
#include "ifswitch.h"
#include "inheritance_constructor.h"
#include "initlist.h"
#include "null.h"
#include "range_based_for.h"
#include "structured_binding.h"
#include "type_inference.h"
#include "variadic_templates.h"

std::vector<std::unique_ptr<ChapterTest>> chapter_2_tests() {
  std::vector<std::unique_ptr<ChapterTest>> chapter_2_tests;

  chapter_2_tests.emplace_back(std::make_unique<NullTest>());
  chapter_2_tests.emplace_back(std::make_unique<IfswitchTest>());
  chapter_2_tests.emplace_back(std::make_unique<ConstExpTest>());
  chapter_2_tests.emplace_back(std::make_unique<InitListTest>());
  chapter_2_tests.emplace_back(std::make_unique<StructuredBindingTest>());
  chapter_2_tests.emplace_back(std::make_unique<TypeInferenceTest>());
  chapter_2_tests.emplace_back(std::make_unique<IfConstexprTest>());
  chapter_2_tests.emplace_back(std::make_unique<RangeBasedForTest>());
  chapter_2_tests.emplace_back(std::make_unique<VariadicTemplates>());
  chapter_2_tests.emplace_back(std::make_unique<DelegateConstructor>());
  chapter_2_tests.emplace_back(std::make_unique<InheritanceConstructor>());

  return chapter_2_tests;
}
